/*
 * Copyright (c) 2021 PSMForums. All rights reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.joshuacerdenia.android.nicefeed.ui.viewmodel

import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.Transformations
import com.joshuacerdenia.android.nicefeed.data.model.SearchResultItem
import com.joshuacerdenia.android.nicefeed.data.remote.FeedSearcher

class SearchFeedsViewModel: FeedAddingViewModel() {

    private val searcher = FeedSearcher(repo.networkMonitor)

    var newQuery: String = ""
    var initialQueryIsMade = false

    val feedIdsLiveData = repo.getFeedIds()
    private val mutableQuery = MutableLiveData<String>()
    val searchResultLiveData: LiveData<List<SearchResultItem>> = Transformations.switchMap(mutableQuery) { query ->
        searcher.getFeedList(query)
    }

    fun onFeedIdsRetrieved(feedIds: List<String>) {
        currentFeedIds = feedIds
    }

    fun performSearch(query: String) {
        mutableQuery.value = query.trim()
    }
}